<template>
  <!-- 列表 -->
  <ContentWrap>
    <el-button
      type="primary"
      plain
      @click="openForm('create')"
      v-hasPermi="['iot:formula:create']"
    >
      <Icon icon="ep:plus" class="mr-5px" /> 新增
    </el-button>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="ID" align="center" prop="id" />
       <el-table-column label="公式编号" align="center" prop="formulaCode" />
      <el-table-column label="变量名称" align="center" prop="name" />
      <el-table-column label="设备ID" align="center" prop="deviceId" />
      <el-table-column label="地址ID" align="center" prop="attributeId" />
      <el-table-column label="地址名称" align="center" prop="attributeName" />
      <el-table-column label="地址" align="center" prop="address" />
      <el-table-column label="示例值" align="center" prop="demoValue" />
      <el-table-column label="累积量类型" align="center" prop="sumType">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.IOT_FORMULA_VAR_TYPE" :value="scope.row.sumType" />
        </template>
      </el-table-column>
      <el-table-column label="计算范围" align="center" prop="sumRange">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.IOT_FORMULA_CAL_RANG" :value="scope.row.sumRange" />
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" />

      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" fixed="right" width="150">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['iot:formula:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['iot:formula:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>
    <!-- 表单弹窗：添加/修改 -->
    <FormulaDetailForm ref="formRef" @success="getList" />
</template>
<script setup lang="ts">
import { DICT_TYPE } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import { FormulaApi } from '@/api/iot/formula'
import FormulaDetailForm from './FormulaDetailForm.vue'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const props = defineProps<{
  formulaId?: number, // 计算公式ID（主表的关联字段）
  formulaCode?: string
}>()
const loading = ref(false) // 列表的加载中
const list = ref([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  formulaId: undefined as unknown
})

/** 监听主表的关联字段的变化，加载对应的子表数据 */
watch(
  () => props.formulaId,
  (val: number) => {
    if (!val) {
      return
    }
    queryParams.formulaId = val
    handleQuery()
  },
    { immediate: true, deep: true }
)

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await FormulaApi.getFormulaDetailPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  if (!props.formulaId) {
    message.error('请选择一个计算公式')
    return
  }
  formRef.value.open(type, id, props.formulaId, props.formulaCode)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await FormulaApi.deleteFormulaDetail(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}
</script>
